### Name: ArmaModelling
### Title: Integrated ARMA Time Series Modelling
### Aliases: ArmaModelling fARMA fARMA-class armaSim armaFit print.fARMA
###   plot.fARMA summary.fARMA predict.fARMA fitted.fARMA coef.fARMA
###   residuals.fARMA armaRoots armaTrueacf
### Keywords: models

### ** Examples

## SOURCE("fSeries.1A-ArmaModelling")
## Not run: 
##D ## armaSim/armaFit -
##D    x = armaSim(model = list(ar = c(0.5, -0.5), ma = 0.1), n = 1000)
##D    # Estimate the parameters:
##D    fit = armaFit(x ~ arma(2, 1))
##D    print(fit)
##D    # Diagnostic Analysis:
##D    par(mfrow = c(3, 2), cex = 0.7)
##D    summary(fit)
##D    # 5 Steps ahead Forecasts:
##D    predict(fit, 5)
##D    
##D ## armaRoots -
##D    # Calculate and plot the roots of an ARMA process:
##D    par(mfrow = c(2, 2), cex = 0.7)
##D    coefficients = c(-0.5, 0.9, -0.1, -0.5)
##D    armaRoots(coefficients)
##D    
##D ## armaTrueacf -
##D    model = list(ar = c(0.3, +0.3), ma = 0.1)
##D    armaTrueacf(model)
##D    model = list(ar = c(0.3, -0.3), ma = 0.1)
##D    armaTrueacf(model)
## End(Not run)



